'''
Convergence
SNES_CONVERGED_ITERATING      still iterating
SNES_CONVERGED_FNORM_ABS      F < F_minabs
SNES_CONVERGED_FNORM_RELATIVE F < F_mintol*F_initial
SNES_CONVERGED_PNORM_RELATIVE step size small
SNES_CONVERGED_TR_DELTA       trust region tol???
Divergence
SNES_DIVERGED_FUNCTION_COUNT  too many function evaluations
SNES_DIVERGED_FNORM_NAN       encountered NaN in residual
SNES_DIVERGED_MAX_IT          too many iterations
SNES_DIVERGED_LS_FAILURE      line search did not produce descent
SNES_DIVERGED_LOCAL_MIN       || J^T b || is small, implies converged to local minimum of F()
'''
SNES_CONVERGED_ITERATING = 0
SNES_CONVERGED_FNORM_ABS = 2
SNES_CONVERGED_FNORM_RELATIVE = 3
SNES_CONVERGED_PNORM_RELATIVE = 4
SNES_CONVERGED_TR_DELTA = 7
SNES_DIVERGED_FUNCTION_COUNT = -2
SNES_DIVERGED_FNORM_NAN = -4
SNES_DIVERGED_MAX_IT = -5
SNES_DIVERGED_LS_FAILURE = -6
SNES_DIVERGED_LOCAL_MIN = -8
